import sys
import random
import datetime
from datetime import timedelta

from ardi.driver import histdriverbase

def fixdate(dt):
	ps = dt.find('.')
	if ps > -1:
		return dt[0:ps]
	return dt

class ardisimdriver:
    def __init__(self):
        self.path = ""
	
    def SetAddress(self, addr):
        self.path = addr
		
    def Connect(self):
		try:		
			self.con = sql.connect(self.path)
			return True
		except:
			return False		
		
    def Disconnect(self):
		self.con.close()
		pass
        
    def Query(self, points, start,end,function,grain,first):
		print "Performing '" + function + "' query on " + str(points) + " between " + start + " and " + end 								

		sd = datetime.datetime.strptime( start, "%Y-%m-%d %H:%M:%S" )
		ed = datetime.datetime.strptime( end, "%Y-%m-%d %H:%M:%S" )

		diff = ed - sd

		secs = diff.seconds + (diff.days * (60*60*24))

		count = 50
		stepsize = secs / count
		step = timedelta(seconds=stepsize)

		#out = "Name, Timestamp, Value\r\n"
		out = ""
		n = 0;
		for x in range(0,count):
			for p in points:
				val = random.random() * 50.0
				out = out + str(n) + "," + str(sd) + "," + str(val) + "\r\n"
				n = n + 1
				sd = sd + step	
		
		return out.encode('ascii')
		            
class driverfactory:
    def createinstance(self):
        return ardisimdriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = histdriverbase.historian()
    base.start(sdf)